Subject: Re: [PATCH] bnx2: Fix IRQ failures during kdump.

From: Matthew Wilcox <[email-masked]>
Date: Sat, 29 May 2010 19:24:01 -0600

On Sat, May 29, 2010 at 04:05:27PM -0700, David Miller wrote:
> From: "Michael Chan" <[email-masked]>
> Date: Sat, 29 May 2010 09:22:07 -0700
> 
> > I think there may be more issues after thinking about it some more.
> > The device is essentially still active at this time.  The PCI
> > layer can turn off certain things, but enabling INTX can lead to
> > "irq x: nobody cared" if the driver is not ready for it.  The
> > device really needs to be reset by the driver to be totally
> > reliable.
> 
> We still have to find some generic way to do this.
> 
> My position still stands, and it is entirely rediculious to
> have every single driver have to attend to all of these
> esoteric details just to handle interrupts properly.  Drivers
> are hard enough to write as-is.

I think we can do this generically.  PCI has disable bits for MSI,
MSI-X and pin-based interrupts.  So we can leave MSIs enabled, but disable
interrupt generation.

We should probably set the interrupt type back to pin-based before the
kexec kernel starts, right?  Or do we expect drivers to handle being
initialised with the device still set to MSI mode?

-- 
Matthew Wilcox				Intel Open Source Technology Centre
"Bill, look, we understand that you're interested in selling us this
operating system, but compare it to ours.  We can't possibly take such
a retrograde step."